module Calculator where

import HtmlScript
import LibRef

{-
Altere a linha seguinte por forma a incluir o PATHNAME absoluto do mdulo
-}
import "c:/MP1/Trab3/hscalc.hs"
  

-------------------------------------------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

sT = [('t':(show n),"Tecla "++(show n)) | n <- [1..30]]


-----------------------------------------------------------
-- This is the access function for use as a scriptlet
-----------------------------------------------------------

-- click event
buttonClicked :: IDispatch a -> String -> IHTMLWindow () -> IO ()
buttonClicked output label window
    = do { num <- output # getInnerText
         ; (window # getExternal ## raiseEvent label num)
             `catch` \err -> return ()      -- no panic if not used as scriptlet
         }


-----------------------------------------------------------
-- Our state transition function
-----------------------------------------------------------

calculate ::  IDispatch a -> String -> Estado -> IO Estado
calculate output tecla xs 
    = do{ let (result,ys) = hscalc (tecla,xs)
        ; output # setInnerText result
        ; return ys
        }
        

-----------------------------------------------------------
-- Attach events to change colors and invoke
-- the "calculate" function
-----------------------------------------------------------
  
liteColor    = "#9BA4A4"
normColor    = "#808080"
        
overColor :: IDispatch a -> IO ()
overColor src
    = do{ src # getStyle ## setColor "white" }
    
normalColor :: IDispatch a -> IO ()
normalColor src
    = do{ src # getStyle ## setColor "black"
        ; src # setBgColor normColor
        }
    
downColor :: IDispatch a -> IO ()
downColor src 
    = do{ src # getStyle ## setColor "white"
        ; src # setBgColor liteColor
        }

--attachSink :: (String -> IO ()) -> IDispatch a 
--                    -> (String,String) -> IHTMLWindow () -> IO ()
attachSink sink output (label,tecla) window
    = do{ src <- window # item label
        ; src # onEvent "onClick" (do{ sink tecla
                                     ; window # buttonClicked output label
                                     })
        ; src # onEvent "onMouseOver" (src # overColor)
        ; src # onEvent "onMouseOut"  (src # normalColor)
        ; src # onEvent "onMouseDown" (src # downColor)
        ; src # onEvent "onMouseUp"   (src # normalColor)
        ; return ()
        }

main :: IO ()
main    
    = do{ window <- extern "window"
        ; output <- window # item "output"
        ; sink   <- stateMachine_1 (calculate output) estado_inicial
        ; window # withMethod_ (attachSink sink output) sT
        }


-----------------------------------------------------------
-- Wrap the calculator state in a 'stateMachine'
-----------------------------------------------------------

stateMachine_1 :: (b -> a -> IO a) -> a -> IO (b -> IO ())
stateMachine_1 f x0     
    =do{ refx <- newRef x0
       ; let g y  = do xin   <- getRef refx
                       xout  <- f y xin
                       setRef refx xout
       ; return g
       }

